// stdafx.h : include file for standard system include files,
// or project specific include files that are used frequently, but
// are changed infrequently
//

#pragma once

#include "targetver.h"

#define WIN32_LEAN_AND_MEAN             // Exclude rarely-used stuff from Windows headers
// Windows Header Files:
#include <windows.h>



// TODO: reference additional headers your program requires here
#include <process.h>
#include<WinSock2.h>
// TODO: reference additional headers your program requires here

struct Sync
{
	CRITICAL_SECTION m_cs;
	Sync()
	{
		::InitializeCriticalSection(&m_cs);
	}

	void lock()
	{
		EnterCriticalSection(&m_cs);
	}

	void unlock()
	{
		LeaveCriticalSection(&m_cs);
	}
	~Sync()
	{
		::DeleteCriticalSection(&m_cs);
	}
};

#define STR_MAX 2048

class String
{
public:
	char string[STR_MAX];

	String(char *buffer="")
	{
		strcpy(string,buffer);
	}
	operator char*()
	{
		return string;
	}
	String operator =(char *str)
	{
		strcpy(string,str);
		return *this;
	}
};

#include<vector>
// --
// Is an array of strings
// --
typedef std::vector<String> stringArray;

//--
// Will return an array of strings depending on the number of token(s) found in the input string
//--

static stringArray tokenizer(char *buffer,char *tokenizer) //will fill 'ret' upon returning
{
	stringArray strArray; 
	strArray.clear();
	String strTemp;
	strcpy(strTemp.string,buffer);
	char *token = strtok( strTemp.string, tokenizer );

	while( token != NULL )
	{
		strcpy(strTemp.string,token);
		strArray.push_back(strTemp);

		token = strtok( NULL, tokenizer );
	}
	return strArray;
}

#define LOGS_FRAPS "c:\\LOGS_FRAPS"

#include <direct.h>
class logger
{
	String m_foldername;
	Sync m_cs;
public:

	logger(char *folder_name)
	{
		_mkdir(folder_name);
		strcpy(m_foldername.string,folder_name);
	}

	void Log(const char *str,int len,DWORD Threadid=::GetCurrentThreadId())
	{
		try{
			m_cs.lock();

			String b;
			::GetModuleFileNameA(0,b,sizeof(b));
			static stringArray strArr=tokenizer(b,"\\");
			
			String filename;
			SYSTEMTIME st;
			GetLocalTime(&st);
			sprintf(filename.string,"%s\\log_%d_%d_%d_PID_%u_%s.log",m_foldername.string,st.wDay,st.wMonth,st.wYear,::GetCurrentProcessId(),strArr[strArr.size()-1].string);

			FILE *fp=fopen(filename.string,"a");
			if(fp)
			{
				fprintf(fp,"\n %02d:%02d:%02d Thread id:%x :- \n",st.wHour,st.wMinute,st.wSecond,Threadid);

				for(int i=0;i<len;i++)
					fprintf(fp,"%c",str[i]);

				fclose(fp);
			}
			else
			{
				_mkdir(m_foldername);
			}

			m_cs.unlock();
		}catch(...)
		{
			//genral exception
		}
	}
};

static void LogString(const char *str,int len)
{
	static logger Logger("c:\\NetSnoop");
	Logger.Log(str,len);
}